package makedeb

import (
	"io"
	"time"
)

type ControlContent struct {
	Attributes ControlFile
	Scripts    []InstallScript
}

func (this *ControlContent) MakeTgz(output io.Writer, ModifyTime time.Time) error {

	tgz, err := NewTarGz(output)
	if err != nil {
		return err
	}
	defer tgz.Close()

	// Files to add to tar: control
	err = tgz.AddContent(this.Attributes.write(), "control", 0644, ModifyTime)
	if err != nil {
		return err
	}

	// Files to add to tar: scripts
	for _, scr := range this.Scripts {
		scrName, err := scr.Type.Name()
		if err != nil {
			return err
		}

		err = tgz.AddContent(scr.Content, scrName, 0755, ModifyTime)
		if err != nil {
			return err
		}
	}

	// All successful
	return nil
}
