/*
Copyright (c) 2016, The `code.ivysaur.me/makedeb` author(s)

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted, provided that the above copyright
notice and this permission notice appear in all copies.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF
THIS SOFTWARE.
*/

package makedeb

import (
	"errors"
)

type InstallScriptType int8

const (
	INSTALLSCRIPT_PREINST  InstallScriptType = 0x10
	INSTALLSCRIPT_POSTINST InstallScriptType = 0x11
	INSTALLSCRIPT_PRERM    InstallScriptType = 0x12
	INSTALLSCRIPT_POSTRM   InstallScriptType = 0x13
)

func (this InstallScriptType) Name() (string, error) {
	switch this {
	case INSTALLSCRIPT_PREINST:
		return "preinst", nil

	case INSTALLSCRIPT_POSTINST:
		return "postinst", nil

	case INSTALLSCRIPT_PRERM:
		return "prerm", nil

	case INSTALLSCRIPT_POSTRM:
		return "postrm", nil

	default:
		return "", errors.New("Unknown installscript type")
	}
}

type InstallScript struct {
	Type    InstallScriptType
	Content string
}
